"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var toResponsiveProps_1 = __importDefault(require("../modules/toResponsiveProps"));
var styled_components_1 = __importDefault(require("styled-components"));
var react_keyed_flatten_children_1 = __importDefault(require("react-keyed-flatten-children"));
var Column_1 = __importDefault(require("./Column"));
var getFlexboxAlignForAlignYProp_1 = __importDefault(require("../modules/getFlexboxAlignForAlignYProp"));
var toResponsiveBreakpoint_1 = __importDefault(require("../modules/toResponsiveBreakpoint"));
var SetTopMarginSpacingHack_1 = __importDefault(require("../components/SetTopMarginSpacingHack"));
var widthPropToDecimal = {
    '1/2': (1 / 2) * 100 + "%",
    '1/3': (1 / 3) * 100 + "%",
    '2/3': (2 / 3) * 100 + "%",
    '1/4': (1 / 4) * 100 + "%",
    '3/4': (3 / 4) * 100 + "%",
    '1/5': (1 / 5) * 100 + "%",
    '2/5': (2 / 5) * 100 + "%",
    '3/5': (3 / 5) * 100 + "%",
    '4/5': (4 / 5) * 100 + "%",
};
var fill = function (defaultFillValue, lengthOfNewArray) {
    return __spread(Array(lengthOfNewArray).keys()).map(function () { return defaultFillValue; });
};
var extractColumnPropsFromChild = function (child) {
    return child && typeof child === 'object' && 'type' in child && child.type === Column_1.default
        ? child.props
        : undefined;
};
var SetColumnStyles = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  ", "\n  ", "\n"], ["\n  ",
    "\n  ",
    "\n"])), function (_a) {
    var columnItem = _a.children;
    var columnProps = extractColumnPropsFromChild(columnItem);
    if ((columnProps === null || columnProps === void 0 ? void 0 : columnProps.width) === 'content')
        return;
    if (!(columnProps === null || columnProps === void 0 ? void 0 : columnProps.width))
        return 'width: 100%;';
    return "width: " + widthPropToDecimal[columnProps.width] + ";";
}, function (_a) {
    var space = _a.space, theme = _a.theme;
    return toResponsiveProps_1.default(space).map(function (space, index) {
        return "\n          " + toResponsiveBreakpoint_1.default(theme, index) + " {\n            padding-top: " + theme.spacing(space) + "px;\n            padding-left: " + theme.spacing(space) + "px;\n          }\n        ";
    });
});
var SetColumnsStyles = styled_components_1.default.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  ", "\n  ", "\n  ", "\n  ", "\n"], ["\n  ",
    "\n  ",
    "\n  ",
    "\n  ",
    "\n"])), function (_a) {
    var reverse = _a.reverse;
    return reverse ? "flex-direction: row-reverse;" : "flex-direction: row;";
}, function (_a) {
    var alignY = _a.alignY, theme = _a.theme;
    return alignY &&
        toResponsiveProps_1.default(alignY).map(function (alignY, index) {
            return alignY &&
                "\n          " + toResponsiveBreakpoint_1.default(theme, index) + " {\n            align-items: " + getFlexboxAlignForAlignYProp_1.default(alignY) + ";\n          }\n        ";
        });
}, function (_a) {
    var space = _a.space, theme = _a.theme;
    return toResponsiveProps_1.default(space).map(function (space, index) {
        return "\n          " + toResponsiveBreakpoint_1.default(theme, index) + " {\n            margin-left: " + theme.spacing(-space) + "px;\n          }\n        ";
    });
}, function (_a) {
    var collapseBelow = _a.collapseBelow, theme = _a.theme;
    var collapseBelowBreakpointName = collapseBelow || theme.breakpoints.keys[0];
    var indexOfCollapseBreakpoint = collapseBelow
        ? theme.breakpoints.keys.indexOf(collapseBelowBreakpointName)
        : 0;
    var responsiveDisplay = indexOfCollapseBreakpoint > 0
        ? __spread(fill('block', indexOfCollapseBreakpoint), ['flex']) : ['flex'];
    return responsiveDisplay.map(function (display, index) {
        return "\n          " + toResponsiveBreakpoint_1.default(theme, index) + " {\n            display: " + display + ";\n          }\n        ";
    });
});
var Columns = function (_a) {
    var alignY = _a.alignY, space = _a.space, reverse = _a.reverse, collapseBelow = _a.collapseBelow, columnItems = _a.children;
    return (react_1.default.createElement(SetTopMarginSpacingHack_1.default, { space: space },
        react_1.default.createElement(SetColumnsStyles, { space: space, alignY: alignY, reverse: reverse, collapseBelow: collapseBelow }, react_keyed_flatten_children_1.default(columnItems).map(function (columnItem, columnItemIndex) { return (react_1.default.createElement(SetColumnStyles, { key: columnItemIndex, space: space }, columnItem)); }))));
};
exports.default = Columns;
var templateObject_1, templateObject_2;
