"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var toResponsiveBreakpoint_1 = __importDefault(require("../modules/toResponsiveBreakpoint"));
var hiddenStyles = function (_a) {
    var above = _a.above, below = _a.below, inline = _a.inline, theme = _a.theme;
    var indexOfHideBelowBreakpoint = below
        ? theme.breakpoints.keys.indexOf(below)
        : -1;
    var indexOfHideAboveBreakpoint = above
        ? theme.breakpoints.keys.indexOf(above)
        : theme.breakpoints.keys.length;
    var responsiveDisplay = theme.breakpoints.keys.map(function (_key, index) {
        return index <= indexOfHideAboveBreakpoint &&
            index >= indexOfHideBelowBreakpoint
            ? inline
                ? 'inline'
                : 'block'
            : 'none';
    });
    return responsiveDisplay.map(function (display, index) {
        return "\n        " + toResponsiveBreakpoint_1.default(theme, index) + " {\n          display: " + display + ";\n        }\n      ";
    });
};
var HiddenSpan = styled_components_1.default.span(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  ", "\n"], ["\n  ", "\n"])), hiddenStyles);
var HiddenDiv = styled_components_1.default.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  ", "\n"], ["\n  ", "\n"])), hiddenStyles);
var Hidden = function (_a) {
    var above = _a.above, below = _a.below, inline = _a.inline, children = _a.children;
    var HiddenElement = inline ? HiddenSpan : HiddenDiv;
    return (react_1.default.createElement(HiddenElement, { above: above, below: below, inline: inline }, children));
};
exports.default = Hidden;
var templateObject_1, templateObject_2;
