"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var toResponsiveProps_1 = __importDefault(require("../modules/toResponsiveProps"));
var react_keyed_flatten_children_1 = __importDefault(require("react-keyed-flatten-children"));
var getFlexboxAlignForAlignProp_1 = __importDefault(require("../modules/getFlexboxAlignForAlignProp"));
var getFlexboxAlignForAlignYProp_1 = __importDefault(require("../modules/getFlexboxAlignForAlignYProp"));
var toResponsiveBreakpoint_1 = __importDefault(require("../modules/toResponsiveBreakpoint"));
var SetTopMarginSpacingHack_1 = __importDefault(require("../components/SetTopMarginSpacingHack"));
var fill = function (defaultFillValue, lengthOfNewArray) {
    return __spread(Array(lengthOfNewArray).keys()).map(function () { return defaultFillValue; });
};
var SetInlineStyles = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  flex-wrap: wrap;\n  flex-direction: row;\n  ", "\n  ", "\n  ", "\n  ", "\n"], ["\n  flex-wrap: wrap;\n  flex-direction: row;\n  ",
    "\n  ",
    "\n  ",
    "\n  ",
    "\n"])), function (_a) {
    var alignY = _a.alignY, theme = _a.theme;
    return alignY &&
        toResponsiveProps_1.default(alignY).map(function (alignY, index) {
            return alignY &&
                "\n          " + toResponsiveBreakpoint_1.default(theme, index) + " {\n            align-items: " + getFlexboxAlignForAlignYProp_1.default(alignY) + ";\n          }\n        ";
        });
}, function (_a) {
    var align = _a.align, theme = _a.theme;
    return align &&
        toResponsiveProps_1.default(align).map(function (align, index) {
            return align &&
                "\n          " + toResponsiveBreakpoint_1.default(theme, index) + " {\n            justify-content: " + getFlexboxAlignForAlignProp_1.default(align) + ";\n          }\n        ";
        });
}, function (_a) {
    var space = _a.space, theme = _a.theme;
    return toResponsiveProps_1.default(space).map(function (space, index) {
        return "\n          " + toResponsiveBreakpoint_1.default(theme, index) + " {\n            margin-left: " + theme.spacing(-space) + "px;\n          }\n        ";
    });
}, function (_a) {
    var collapseBelow = _a.collapseBelow, theme = _a.theme;
    var collapseBelowBreakpointName = collapseBelow || theme.breakpoints.keys[0];
    var indexOfCollapseBreakpoint = collapseBelow
        ? theme.breakpoints.keys.indexOf(collapseBelowBreakpointName)
        : 0;
    var responsiveDisplay = indexOfCollapseBreakpoint > 0
        ? __spread(fill('block', indexOfCollapseBreakpoint), ['flex']) : ['flex'];
    return responsiveDisplay.map(function (display, index) {
        return "\n          " + toResponsiveBreakpoint_1.default(theme, index) + " {\n            display: " + display + ";\n          }\n        ";
    });
});
var SetInlineItemStyles = styled_components_1.default.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  min-width: 0%;\n  display: flex;\n  ", "\n  ", "\n"], ["\n  min-width: 0%;\n  display: flex;\n  ",
    "\n  ",
    "\n"])), function (_a) {
    var align = _a.align, theme = _a.theme;
    return align &&
        toResponsiveProps_1.default(align).map(function (align, index) {
            return align &&
                "\n          " + toResponsiveBreakpoint_1.default(theme, index) + " {\n            justify-content: " + getFlexboxAlignForAlignProp_1.default(align) + ";\n          }\n        ";
        });
}, function (_a) {
    var space = _a.space, theme = _a.theme;
    return toResponsiveProps_1.default(space).map(function (space, index) {
        return "\n          " + toResponsiveBreakpoint_1.default(theme, index) + " {\n            padding-top: " + theme.spacing(space) + "px;\n            padding-left: " + theme.spacing(space) + "px;\n          }\n        ";
    });
});
var Inline = function (_a) {
    var space = _a.space, align = _a.align, alignY = _a.alignY, collapseBelow = _a.collapseBelow, inlineItems = _a.children;
    return (react_1.default.createElement(SetTopMarginSpacingHack_1.default, { space: space },
        react_1.default.createElement(SetInlineStyles, { space: space, align: align, alignY: alignY, collapseBelow: collapseBelow }, react_keyed_flatten_children_1.default(inlineItems).map(function (inlineItem, inlineItemIndex) { return (react_1.default.createElement(SetInlineItemStyles, { align: align, space: space, key: inlineItemIndex }, inlineItem)); }))));
};
exports.default = Inline;
var templateObject_1, templateObject_2;
