"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var toResponsiveProps_1 = __importDefault(require("../modules/toResponsiveProps"));
var getFlexboxAlignForAlignProp_1 = __importDefault(require("../modules/getFlexboxAlignForAlignProp"));
var react_keyed_flatten_children_1 = __importDefault(require("react-keyed-flatten-children"));
var Hidden_1 = __importDefault(require("./Hidden"));
var styled_components_1 = __importDefault(require("styled-components"));
var SetTopMarginSpacingHack_1 = __importDefault(require("../components/SetTopMarginSpacingHack"));
var toResponsiveBreakpoint_1 = __importDefault(require("../modules/toResponsiveBreakpoint"));
var extractHiddenPropsFromChild = function (child) {
    return child && typeof child === 'object' && 'type' in child && child.type === Hidden_1.default
        ? child.props
        : null;
};
var SetStackItemSpacing = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  height: 100%;\n  ", "\n  ", "\n"], ["\n  height: 100%;\n  ",
    "\n  ",
    "\n"])), function (_a) {
    var space = _a.space, theme = _a.theme;
    return toResponsiveProps_1.default(space).map(function (space, index) {
        return "\n          " + toResponsiveBreakpoint_1.default(theme, index) + " {\n            padding-top: " + theme.spacing(space) + "px;\n          }\n        ";
    });
}, function (_a) {
    var stackItem = _a.children, theme = _a.theme;
    var hiddenProps = extractHiddenPropsFromChild(stackItem);
    var indexOfHideBelowBreakpoint = (hiddenProps === null || hiddenProps === void 0 ? void 0 : hiddenProps.below) ? theme.breakpoints.keys.indexOf(hiddenProps.below)
        : 0;
    var indexOfHideAboveBreakpoint = (hiddenProps === null || hiddenProps === void 0 ? void 0 : hiddenProps.above) ? theme.breakpoints.keys.indexOf(hiddenProps.above)
        : theme.breakpoints.keys.length - 1;
    var responsiveDisplay = theme.breakpoints.keys.map(function (_key, index) {
        return index <= indexOfHideAboveBreakpoint &&
            index >= indexOfHideBelowBreakpoint
            ? 'block'
            : 'none';
    });
    return responsiveDisplay.map(function (display, index) {
        return "\n          " + toResponsiveBreakpoint_1.default(theme, index) + " {\n            display: " + display + ";\n          }\n        ";
    });
});
var SetStackAlignment = styled_components_1.default.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  display: flex;\n  flex-direction: column;\n  ", "\n"], ["\n  display: flex;\n  flex-direction: column;\n  ",
    "\n"])), function (_a) {
    var align = _a.align, theme = _a.theme;
    return align &&
        toResponsiveProps_1.default(align).map(function (align, index) {
            return align &&
                "\n          " + toResponsiveBreakpoint_1.default(theme, index) + " {\n            align-items: " + getFlexboxAlignForAlignProp_1.default(align) + ";\n          }\n        ";
        });
});
var Stack = function (_a) {
    var stackItems = _a.children, space = _a.space, align = _a.align;
    return (react_1.default.createElement(SetTopMarginSpacingHack_1.default, { space: space },
        react_1.default.createElement(SetStackAlignment, { align: align }, react_keyed_flatten_children_1.default(stackItems).map(function (stackItem, stackItemIndex) { return (react_1.default.createElement(SetStackItemSpacing, { key: stackItemIndex, space: space }, stackItem)); }))));
};
exports.default = Stack;
var templateObject_1, templateObject_2;
