"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var toResponsiveProps_1 = __importDefault(require("../modules/toResponsiveProps"));
var react_keyed_flatten_children_1 = __importDefault(require("react-keyed-flatten-children"));
var styled_components_1 = __importDefault(require("styled-components"));
var SetTopMarginSpacingHack_1 = __importDefault(require("../components/SetTopMarginSpacingHack"));
var toResponsiveBreakpoint_1 = __importDefault(require("../modules/toResponsiveBreakpoint"));
var SetTilesSpacing = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  flex-wrap: wrap;\n  display: flex;\n  ", "\n"], ["\n  flex-wrap: wrap;\n  display: flex;\n  ",
    "\n"])), function (_a) {
    var space = _a.space, theme = _a.theme;
    return toResponsiveProps_1.default(space).map(function (space, index) {
        return "\n          " + toResponsiveBreakpoint_1.default(theme, index) + " {\n            margin-left: " + theme.spacing(-space) + "px;\n          }\n        ";
    });
});
var SetTilesItemWidth = styled_components_1.default.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  min-width: 0%;\n  flex-grow: 0;\n  flex-shrink: 0;\n  ", "\n"], ["\n  min-width: 0%;\n  flex-grow: 0;\n  flex-shrink: 0;\n  ",
    "\n"])), function (_a) {
    var columns = _a.columns, theme = _a.theme;
    if (columns === undefined)
        return;
    var responsiveFlexBasis = toResponsiveProps_1.default(columns).map(function (columns) { return 100 / columns + '%'; });
    return responsiveFlexBasis.map(function (flexBasis, index) {
        return flexBasis &&
            "\n          " + toResponsiveBreakpoint_1.default(theme, index) + " {\n              flex-basis: " + flexBasis + ";\n          }\n        ";
    });
});
var SetTilesItemSpacing = styled_components_1.default.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  height: 100%;\n  ", "\n"], ["\n  height: 100%;\n  ",
    "\n"])), function (_a) {
    var space = _a.space, theme = _a.theme;
    return toResponsiveProps_1.default(space).map(function (space, index) {
        return "\n          " + toResponsiveBreakpoint_1.default(theme, index) + " {\n            padding-top: " + theme.spacing(space) + "px;\n            padding-left: " + theme.spacing(space) + "px;\n          }\n        ";
    });
});
var Tiles = function (_a) {
    var tilesItems = _a.children, space = _a.space, columns = _a.columns;
    return (react_1.default.createElement(SetTopMarginSpacingHack_1.default, { space: space },
        react_1.default.createElement(SetTilesSpacing, { space: space }, react_keyed_flatten_children_1.default(tilesItems).map(function (tilesItem, tileIndex) { return (react_1.default.createElement(SetTilesItemWidth, { key: tileIndex, columns: columns },
            react_1.default.createElement(SetTilesItemSpacing, { space: space }, tilesItem))); }))));
};
exports.default = Tiles;
var templateObject_1, templateObject_2, templateObject_3;
