"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getStaticProps = exports.getStaticPaths = exports.preRenderCodeExample = void 0;
var react_1 = __importDefault(require("react"));
var react_element_to_jsx_string_1 = __importDefault(require("react-element-to-jsx-string"));
var standalone_1 = __importDefault(require("prettier/standalone"));
var parser_typescript_1 = __importDefault(require("prettier/parser-typescript"));
var playroom_1 = require("playroom");
var Doc_1 = __importDefault(require("../../components/demo/Doc"));
var Box_docs_1 = __importDefault(require("../../components/Box.docs"));
var Tiles_docs_1 = __importDefault(require("../../components/Tiles.docs"));
var Column_docs_1 = __importDefault(require("../../components/Column.docs"));
var Columns_docs_1 = __importDefault(require("../../components/Columns.docs"));
var Hidden_docs_1 = __importDefault(require("../../components/Hidden.docs"));
var Inline_docs_1 = __importDefault(require("../../components/Inline.docs"));
var Stack_docs_1 = __importDefault(require("../../components/Stack.docs"));
var baseUrl = process.env.NODE_ENV === 'development'
    ? "http://localhost:2223/"
    : "https://mui-primitives.hackart.live/playroom";
var usePrettierToFormatSnippet = function (snippet) {
    return standalone_1.default
        .format(snippet, {
        parser: 'typescript',
        plugins: [parser_typescript_1.default],
        semi: false,
    })
        .replace(/^;/, '');
};
exports.preRenderCodeExample = function (example) {
    var code = usePrettierToFormatSnippet(react_element_to_jsx_string_1.default(example.Example(), {
        useBooleanShorthandSyntax: true,
    }));
    return {
        code: code,
        playroomUrl: playroom_1.createUrl({ code: code, baseUrl: baseUrl }).replace('/#', '#'),
    };
};
var docs = {
    box: Box_docs_1.default,
    column: Column_docs_1.default,
    columns: Columns_docs_1.default,
    hidden: Hidden_docs_1.default,
    inline: Inline_docs_1.default,
    stack: Stack_docs_1.default,
    tiles: Tiles_docs_1.default,
};
exports.getStaticPaths = function () { return __awaiter(void 0, void 0, void 0, function () {
    var paths;
    return __generator(this, function (_a) {
        paths = [
            { params: { component: 'box' } },
            { params: { component: 'column' } },
            { params: { component: 'columns' } },
            { params: { component: 'hidden' } },
            { params: { component: 'inline' } },
            { params: { component: 'stack' } },
            { params: { component: 'tiles' } },
        ];
        return [2 /*return*/, { paths: paths, fallback: false }];
    });
}); };
exports.getStaticProps = function (_a) {
    var params = _a.params;
    return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_b) {
            return [2 /*return*/, ({
                    props: {
                        component: params === null || params === void 0 ? void 0 : params.component,
                        codeExamples: docs[params === null || params === void 0 ? void 0 : params.component].examples.map(exports.preRenderCodeExample),
                    },
                })];
        });
    });
};
var Docs = function (_a) {
    var codeExamples = _a.codeExamples, component = _a.component;
    return (react_1.default.createElement(Doc_1.default, { codeExamples: codeExamples, doc: docs[component] }));
};
exports.default = Docs;
